



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Luogu P4479 [BJWC2018]第k大斜率</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Luogu P4479 [BJWC2018]第k大斜率</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-28 22:07:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一道清真简单的好写的题</p>
<p><a href="P4479%20[BJWC2018]第k大斜率" rel="external nofollow noreferrer">Luogu&nbsp;P4479</a></p>
<hr />
<h3>题意</h3>
<p>求点集两两连出的直线中斜率第$ k$大的直线</p>
<hr />
<p>$ Solution$</p>
<p>二分答案，设$x_j \geq x_i$</p>
<p>若点$ (x_i,y_i)$和点$(x_j,y_j)$构成的斜率大于二分的答案$ k$则有</p>
<p>$ \frac{y_j-y_i}{x_j-x_i} \geq k$</p>
<p>$y_j-k&middot;x_j \geq y_i-k&middot;x_i$</p>
<p>转化成二维偏序</p>
<p>树状数组/归并排序维护即可</p>
<p>注意特判各种边界问题</p>
<p>时间复杂度$ O(n \log^2 n)$</p>
<hr />
<p>$ my \ code$</p>
<div>
<pre class="prettyprint linenums">#include&lt;ctime&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;queue&gt;<br />
#define rt register int<br />
#define ll long long<br />
using namespace std;<br />
inline ll read(){<br />
    ll x = ; char zf = ; char ch = getchar();<br />
    while (ch != '-' &amp;&amp; !isdigit(ch)) ch = getchar();<br />
    if (ch == '-') zf = -, ch = getchar();<br />
    while (isdigit(ch)) x = x *  + ch - '', ch = getchar(); return x * zf;<br />
}<br />
void write(ll y){if(y&lt;)putchar('-'),y=-y;if(y&gt;)write(y/);putchar(y%+);}<br />
void writeln(const ll y){write(y);putchar('\n');}<br />
ll n,m;<br />
struct node{<br />
    int x,y;<br />
    bool operator &lt;(const node s)const{<br />
        if(x==s.x)return y&gt;s.y;<br />
        return x&lt;s.x;<br />
    }<br />
}a[];<br />
ll q[],zs[],ans;<br />
ll calc(int L,int R){<br />
    if(L==R)return ;<br />
    if(ans&gt;=m)return ans;<br />
    const int mid=L+R&gt;&gt;;<br />
    calc(L,mid);calc(mid+,R);if(ans&gt;=m)return ans;<br />
    for(rt i=mid+,j=L;i&lt;=R;i++){<br />
        while(j&lt;=mid&amp;&amp;q[j]&lt;=q[i])j++;<br />
        ans+=j-L;<br />
    }<br />
    int tot1=L,tot2=mid+,pl=L;<br />
    while(tot1&lt;=mid||tot2&lt;=R){<br />
        if(tot1&gt;mid||(q[tot1]&gt;q[tot2]&amp;&amp;tot2&lt;=R))zs[pl++]=q[tot2++];<br />
        else zs[pl++]=q[tot1++];<br />
    }<br />
    for(rt i=L;i&lt;=R;i++)q[i]=zs[i];<br />
    return ans;<br />
}<br />
bool check(int x){<br />
    ans=;<br />
    for(rt i=;i&lt;=n;i++)q[i]=(ll)a[i].y-(ll)x*a[i].x;<br />
    return (calc(,n)&gt;=m);<br />
}<br />
int main(){<br />
    n=read();m=read();<br />
    for(rt i=;i&lt;=n;i++)a[i].x=read(),a[i].y=read();<br />
    sort(a+,a+n+);<br />
    int L=-,R=;<br />
    while(L&lt;=R){<br />
        const int mid=L+R&gt;&gt;;<br />
        if(check(mid))L=mid+;<br />
        else R=mid-;<br />
    }<br />
    write(R);<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390277nq.html">WNMP集成环境下配置thinkPHP</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gn0kq.html">网络虚拟化中的 offload 技术：LSO&sol;LRO、GSO&sol;GRO、TSO&sol;UFO、VXLAN</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9625xvq.html">ASP&period;NET的新成员ASP&period;NET WebHooks</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnrkj29.html">css3 transition属性变化与animation动画的相似性以及不同点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1o3mr9.html">Mysql主从数据库架构的复制原理及配置详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj5v0y9.html">iOS-本地推送（本地通知）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdm41l8.html">oracle 零散知识汇集</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5lkjq.html">y combinator 做的一个调查&lowbar;可以学习一下</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde5ngq.html">As Easy As A&plus;B</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjond38.html">浅谈测试rhel7新功能时的感受及遇到的问题【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1x6n8.html">●BZOJ 3963 &lbrack;WF2011&rsqb;MachineWorks</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zo4n59.html">这么用Mac才叫爽！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4m6k9.html">Add In 简介（主要翻译于ESRI官方文档）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zvkdq.html">jsapi 调起微信支付的的踩坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rjjl39.html">npmrc npm配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jmrznq.html">pythonのsqlalchemy外键关联查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2mo18.html">《Practical Vim》第十章&colon;复制和粘贴</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7ny59.html">LVS原理详解（3种工作方式8种调度算法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnmr1xq.html">Django-基本指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p5xn0q.html">poj3734 Blocks&lbrack;矩阵优化dp or 组合数学&rsqb;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wdo6zq.html">zabbix自动发现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdowge9.html">luogu4211 LCA</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gmxlmq.html">第一篇-Win10打开txt文件出现中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7olzn18.html">【译】3&period; Java反射&mdash;&mdash;构造函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2l2joq.html">my97DatePicker选择年、季度、月、周、日（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlln1xkq.html">（01背包 dp）P1049 装箱问题 洛谷</a>
			</li>
						<li><a href="https://www.batexi.com/a/96077o49.html">CodeForces999E  双dfs &sol;&sol; 标记覆盖 &sol;&sol; tarjan缩点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1v5oeq.html">docker仓库harbor搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjpe49.html">No Spring WebApplicationInitializer types detected on classpath</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e45j3k9.html">设计模式---接口隔离模式之中介者模式（Mediator）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
